# -*- coding: latin-1 -*-
'''
knowledgeBase.py

Copyright 2007 Mariano Nuez Di Croce @ CYBSEC

This file is part of sapyto, http://www.cybsec.com/EN/research/tools/sapyto.php

sapyto is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation version 2 of the License.

sapyto is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with sapyto; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
'''
class knowledgeBase:
	'''
	This class records all data saved by plugins. 
	
	@author: Mariano Nuez Di Croce <mnunez@cybsec.com> 
	'''
	
	def __init__(self):
		self._kb = {}		
	
	def save( self, callingInstance, key, value):
		'''
		Save the specified value in the kb dictionary, according to the key specified.
		'''
		name = callingInstance.__class__.__name__
		if name == 'str':
			name = callingInstance
		if name not in self._kb.keys():
			self._kb[ name ] = { key: value }			
		else:
			self._kb[ name ][ key ] = value		
			
	def append( self, callingInstance, key, value , unique=False):
		'''
		Append the specified value to the KB dict.
		'''
		name = callingInstance.__class__.__name__
		if name == 'str':
			name = callingInstance
		if name not in self._kb.keys():
			self._kb[ name ] = { key: [value,] }
		else:
			if key in self._kb[name].keys():
				if (unique and value not in self._kb[name][key]) or not unique:
					self._kb[ name ][ key ].extend([value,])				
			else:
				self._kb[ name ][ key ] = [value,]
				
	
	def getData ( self, plugin, key ):
		'''
		@return: value saved in the KB by plugin
		'''
		res = []
		if plugin not in self._kb.keys():
			res = []
		else:
			if key not in self._kb[ plugin ].keys():
				res = []
			else:
				res = self._kb[ plugin ][ key ]		
		return res
		
# Make KB world-available
kb = knowledgeBase()
