# -*- coding: latin-1 -*-
'''
baseCallBackHandler.py

Copyright 2007 Mariano Nuez Di Croce @ CYBSEC

This file is part of sapyto, http://www.cybsec.com/EN/research/tools/sapyto.php

sapyto is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation version 2 of the License.

sapyto is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with sapyto; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
'''
class baseCallBackHandler:
	'''
	This class represents a base callback handler to use in external registered servers.
	Callback handlers should inherit from it and MUST implement the handler() method.
	'''
	def __init__(self):
		self.cnt = 0
		self._sapyto = None
		self._commands = []
	
	def LoopHandler(self, srfc):
		self.cnt += 1
		if self.cnt >= 30000:
				return -1
		return 1
		
	def handler(self, iface, srfc):
		'''
		Implement Function Call handling code in concrete callback handlers.
		'''
	
	# This is ugly!!!
	def setCore(self, sapyto):
		self._sapyto = sapyto
	
	def setCommands(self, commands):
		self._commands = commands
