# -*- coding: latin-1 -*-
'''
getPassword.py

Copyright 2007 Mariano Nuez Di Croce @ CYBSEC

This file is part of sapyto, http://www.cybsec.com/EN/research/tools/sapyto.php

sapyto is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation version 2 of the License.

sapyto is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with sapyto; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
'''
import core.sapytoCore as core
from core.basePlugins.basePlugin import basePlugin
import core.kb.knowledgeBase as kb
import core.output.outputManager as om
import saprfcutil
import plugins.audit.checkRfcexec as audit
from saprfc import *
from core.misc import *
import re
import copy

# Will be moved to a 'tools' section on next release.
class getPassword(basePlugin):
	'''
	De-obfuscates RFC captured password.
	
	@author: Mariano Nuez Di Croce <mnunez@cybsec.com>
	'''
	
	def __init__(self):
		basePlugin.__init__( self )
		self._iface = None
		self._targets = {}
		self._passwd = 'e5 bf 21 67 00 61 79 68 77 68'
		
	def run( self ):
		om.out.information('Starting \'getPassword\' attack plugin.')
		om.out.information('\tPassword loaded: ', newLine=False)
		om.out.information(self._passwd)
		self._passwd = reverseRFCPassword(self._passwd)
		om.out.information('\tPassword de-obfuscated: ', newLine=False)
		om.out.information(self._passwd)
		om.out.information('Plugin \'getPassword\' finished.')
		
	def getOptionsXML(self):
		'''
		This method returns a XML containing the Options that the plugin has.
		Using this XML the framework will build a window, a menu, or some other input method to retrieve
		the info from the user. The XML has to validate against the xml schema file located at :
		sapyto/core/ui/userInterface.dtd
		
		@return: XML with the plugin options.
		'''	
		return	'<?xml version="1.0" encoding="ISO-8859-1"?>\
		<OptionList>\
			<Option name="passwd">\
				<default>e5 bf 21 67 00 61 79 68 77 68</default>\
				<desc>Obfuscated password</desc>\
				<type>String</type>\
			</Option>\
		</OptionList>\
		'

	def setOptions( self, OptionList ):
		'''
		This method sets all the options that are configured using the user interface 
		generated by the framework using the result of getOptionsXML().
		
		@parameter OptionList: A dictionary with the options for the plugin.
		@return: No value is returned.
		'''	
		if 'passwd' in OptionList.keys(): 
			self._passwd = OptionList['passwd']
