# -*- coding: latin-1 -*-
'''
console.py

Copyright 2007 Mariano Nuez Di Croce @ CYBSEC

This file is part of sapyto, http://www.cybsec.com/EN/research/tools/sapyto.php

sapyto is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation version 2 of the License.

sapyto is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with sapyto; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
'''

from core.basePlugins.baseOutputPlugin import baseOutputPlugin
import sys

class console(baseOutputPlugin):
	'''
	This plugin prints all messages to the console.
	
	@author: Andres Riancho ( andres.riancho@gmail.com )
	'''
	
	def __init__(self):
		baseOutputPlugin.__init__(self)
		self.verbosity = 0

	def debug(self, message, newLine = True ):
		'''
		This method is called from the output object. The output object was called from a plugin
		or from the framework. This method should take an action for debug messages.
		'''
	
		toPrint = str ( message )
		if newLine == True:
			toPrint += '\n'
		sys.stdout.write( toPrint )

	
	def information(self, message , newLine = True ):
		'''
		This method is called from the output object. The output object was called from a plugin
		or from the framework. This method should take an action for informational messages.
		'''	
		toPrint = str ( message )
		if newLine == True:
			toPrint += '\n'
		sys.stdout.write( toPrint )


	def error(self, message , newLine = True ):
		'''
		This method is called from the output object. The output object was called from a plugin
		or from the framework. This method should take an action for error messages.
		'''		
		toPrint = str ( message )
		if newLine == True:
			toPrint += '\n'
		sys.stderr.write( toPrint )

	def vulnerability(self, message , newLine = True ):
		'''
		This method is called from the output object. The output object was called from a plugin
		or from the framework. This method should take an action when a vulnerability is found.
		'''		
		toPrint = str ( message )
		if newLine == True:
			toPrint += '\n'
		sys.stdout.write( toPrint )
		
	def console( self, message, newLine = True ):
		'''
		This method is used by the sapyto console to print messages to the outside.
		'''
		toPrint = str( message )
		if newLine == True:
			toPrint += '\n'
		sys.stdout.write( toPrint )

	def logHttp( self, request, response):
		pass
