# -*- coding: latin-1 -*-
'''
fuzzer.py

Copyright 2007 Mariano Nuez Di Croce @ CYBSEC

This file is part of sapyto, http://www.cybsec.com/EN/research/tools/sapyto.php

sapyto is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation version 2 of the License.

sapyto is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with sapyto; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
'''
from string import letters, digits
from random import choice, randint

class fuzzer:

	def createRandAlpha(self, length=0):
		'''
		Create a random string ONLY with letters
		
		@return: A random string only composed by letters.
		'''
		if length == 0:
			jibber = ''.join([letters])
			ru = ''.join([choice(jibber) for x in range(randint(10, 30))])
		else:
			jibber = ''.join([letters])
			ru = ''.join([choice(jibber) for x in range(length)])
		return ru
		
	def createRandAlNum(self, length=0):
		'''
		Create a random string with random length
		
		@return: A random string of with length > 10 and length < 30.
		'''
		if length == 0:
			jibber = ''.join([letters, digits])
			ru = ''.join([choice(jibber) for x in range(randint(10, 30))])
		else:
			jibber = ''.join([letters, digits])
			ru = ''.join([choice(jibber) for x in range(length)])
		return ru

	def createRandNum(self, length=0):
		'''
		Create a random string ONLY with numbers
		
		@return: A random string only composed by numbers.
		'''
		if length == 0:
			jibber = ''.join([digits])
			ru = ''.join([choice(jibber) for x in range(randint(10, 30))])
		else:
			jibber = ''.join([digits])
			ru = ''.join([choice(jibber) for x in range(length)])
		return ru
		
	def createFormatString( self, length ):
		'''
		@return: A string with $length %s and a final %n
		'''
		result = ''
		for i in range(length):
			result += '%s'
		result += '%n'
		
		return result
